#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_DS18B20/18F45K22_DS18B20_OneWire.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f45k22_readyforpic_ds18b20/../common/string_routines.h"




void strConstRamCpy(char *dest, const char *source)
{
 while(*source) *(dest++) = *(source++) ;
 *dest = 0 ;
}

void fltToa (double x, unsigned char *str,char precision)
{


int ie, i, k, ndig;
double y;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;

if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }
 ndig += ie;


for (y = i = 1; i < ndig; i++)
 y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
*str = '\0';
}
#line 42 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_DS18B20/18F45K22_DS18B20_OneWire.c"
 sbit LCD_RS at LATD2_bit;
 sbit LCD_EN at LATD3_bit;
 sbit LCD_D4 at LATD4_bit;
 sbit LCD_D5 at LATD5_bit;
 sbit LCD_D6 at LATD6_bit;
 sbit LCD_D7 at LATD7_bit;

 sbit LCD_RS_Direction at TRISD2_bit;
 sbit LCD_EN_Direction at TRISD3_bit;
 sbit LCD_D4_Direction at TRISD4_bit;
 sbit LCD_D5_Direction at TRISD5_bit;
 sbit LCD_D6_Direction at TRISD6_bit;
 sbit LCD_D7_Direction at TRISD7_bit;






const unsigned short TEMP_RES_B = 12;
const unsigned short TEMP_RES_S = 9;





sbit DS18B20_Sensor1 at PORTE.B0;
sbit DS18B20_Sensor1_Direction at TRISE.B0;
char *text = "000.00000";
char Tp[]="000.000000";
float Tf;
unsigned char j1, j2, j3, j4, j5, j6, j7, j8,j9 ;
unsigned char tmp_sign;
float res;
unsigned short TEMP_RESOLUTION;
unsigned temp;





char family_code;
char family_code_hex[2];
char sernum[8];
char sernum_hex[2];
int col;




unsigned char CRam1[64];
char TEXTE[128];
char *txt;
char IntValue[12];
char txt0[] = " Ready for PIC  ";
char txt1[] = "18F45K22 proto  ";
char txt2[] = "with bootloader ";
char txt3[] = "Test DS18B20 12b";
char txt4[] = "Mesure ";

unsigned int Flag_Timer0;
unsigned int Cpt0;
unsigned int Flag_Timer1;
unsigned int Cpt1;

unsigned int i,j,k,l;
unsigned int M;
unsigned int EA0, temp_res;
unsigned int Table_EA[8][8];
unsigned int Nbval;
unsigned Somme_EA[8];

unsigned long Freq;
float f1;



unsigned char buffer1[ 128 ];
unsigned int Index1=0;
unsigned int i1=0;
unsigned int UART1_DataReady=0;
unsigned char c1=0;
unsigned char *p1;



void Interrupts() iv 0x0008 ics ICS_AUTO
{


 if((RC1IF_bit==1) && (RC1IE_bit==1))
 {
 c1 = RCREG1;

 if(OERR1_bit)
 {
 CREN1_bit = 0;
 CREN1_bit = 1;
 }
 if(FERR1_bit)
 {
 c1 = RCREG1;

 }

 if (c1==13)
 {
 UART1_DataReady=1;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }
 if (i1 >= 128 )
 {
 UART1_DataReady=2;
 RC1IE_bit=0 ;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 }
#line 196 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_DS18B20/18F45K22_DS18B20_OneWire.c"
 if((TMR1IE_bit==1) && (TMR1IF_bit==1))
 {

 Cpt1++;
 if (Cpt1>100)
 {
 TXREG1='$';
 Cpt1=0;
 }
 Flag_Timer1=1;
 TMR1ON_bit=0;

 TMR1H= 0x6D;
 TMR1L =0x84 ;
 TMR1IF_bit=0;
 }

}

void Init_Timer4()
 {
 T4CON=0;

 T4CKPS1_bit=0;
 T4CKPS0_bit=1;

 T4OUTPS3_bit=0;
 T4OUTPS2_bit=1;
 T4OUTPS1_bit=1;
 T4OUTPS0_bit=1;
 TMR4=0;
 PR4= 50 ;
 TMR4IF_bit=0;
 TMR4IE_bit=0;
 TMR4ON_bit=0;
 IPR5.TMR4IP=0;
}

void Init_Timer1(void)
{


 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 T1OSCEN_bit=0;
 T1CON.SYNC=0;
 T1CON.TMR1CS1=0;
 T1CON.TMR1CS0=0;
 T1CON.TMR1ON=0;


 TMR1H= 0x6D;
 TMR1L =0x84 ;

 IPR1.TMR1IP=1;
 RCON.IPEN = 1;

 TMR1IF_bit=0;
 INTCON.PEIE = 0;
 T1CON.TMR1ON=0;
 PIE1.TMR1IE=0;
 GIE_bit = 0;
}


void UART1_Write_CText(const char *txt1)
{
 while (*txt1)
 UART1_Write(*(txt1++));
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

 void RAZ_UART1()
{
 RC1IE_bit=0 ;
 for (i1=0;i1< 128 ;i1++) buffer1[i1]=0;
 i1=0;
 Index1=0;
 c1=RCREG1;
 c1=0;
 UART1_DataReady=0;
 RC1IE_bit=1 ;
}


void Init_Hardware()
{
 PMD0=0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 PORTB = 0;
 TRISB=0xFF;
 ANSELB=0;

 PORTA = 0xFF;
 TRISA=0b11100111 ;
 ANSELA=0x01;

 ANSELC=0;
 PORTC = 0xFF;
 TRISC=0b11111111 ;

 ANSELE=0;
 TRISE=0;
 PORTE=0xFF;

 PORTD = 0;
 TRISD=0;
 ANSELD = 0;
 HLVDCON.HLVDEN=0;
 }

void Resolution()
{
 Ow_Reset( &PORTE,0 );
 Ow_Write( &PORTE,0 , 0x33);
 Delay_us(120);
 family_code = Ow_Read( &PORTE,0 );
 switch( family_code )
 {
 case 0x28:
 TEMP_RESOLUTION = TEMP_RES_B;
 break;
 case 0x10:
 TEMP_RESOLUTION = TEMP_RES_S;
 break;
 case 0x01:
 TEMP_RESOLUTION = 0;
 break;
 case 0xFF:
 TEMP_RESOLUTION = 0;
 break;
 default:
 TEMP_RESOLUTION = 0;
 break;
 }

 Ow_Reset( &PORTE,0 );
 Ow_Write( &PORTE,0 , 0x33);
 Delay_ms(750);
 for(i = 0; i <= 7; i++)
 {
 sernum[i] = Ow_Read( &PORTE,0 );
 }
}

void Read_Temperature()
{

 Ow_Reset( &PORTE,0 );
 Ow_Write( &PORTE,0 , 0xCC);
 Ow_Write( &PORTE,0 , 0x44);
 Delay_us(120);

 Ow_Reset( &PORTE,0 );
 Ow_Write( &PORTE,0 , 0xCC);
 Ow_Write( &PORTE,0 , 0xBE);

 temp = Ow_Read( &PORTE,0 );
 temp = (Ow_Read( &PORTE,0 ) << 8) + temp;
}

void Display_SerialNumber()
{
 int i;
 int col = 17;
 CRam1[0]=0;

 UART1_Write_CText("Code ID identification 64 bits = ");

 for(i = 0; i <= 7; i++)
 {
 col = col - 2;
 ByteToHex(sernum[i], sernum_hex);
 Lcd_Out(1, col, sernum_hex);
 Delay_ms(50);
 CRam1[7-i]=sernum[i] ;
 }

 for (i=0;i<=7;i++)
 {
 ByteToHex(CRam1[i],sernum_hex) ;
 UART1_Write_Text(sernum_hex );
 }
 CRLF1() ;

}


void Display_Type()
{
 switch( family_code )
 {
 case 0x28:
 Lcd_Out(2, 1, "18B20");
 break;
 case 0x10:
 Lcd_Out(2, 1, "18S20");
 break;
 case 0x01:
 Lcd_Out(2, 1, "DS1990");
 break;
 case 0xFF:
 Lcd_Out(2, 1, "NoID  ");
 break;
 default:
 ByteToHex(family_code, family_code_hex);
 Lcd_Out(2, 1, family_code_hex );
 break;
 }


 UART1_Write_CText("Code hexa Famille : ");
 switch( family_code )
 {
 case 0x28:
 UART1_Write_CText(" 18B20: ");
 break;
 case 0x10:
 UART1_Write_CText("18S20");
 break;
 case 0x01:
 UART1_Write_CText("DS1990");
 break;
 case 0xFF:
 UART1_Write_CText( "NoID  ");
 break;
 default:
 ByteToHex(family_code, family_code_hex);
 UART1_Write_Text(family_code_hex );
 break;
 }

}

void Display_Temperature()
{
 unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
 char temp_whole;
 unsigned int temp2write;
 unsigned int temp_fraction;
 temp2write = temp;

 if (temp2write & 0x8000)
 {
 text[0] = '-';
 temp2write = ~temp2write + 1;
 }

 temp_whole = temp2write >> RES_SHIFT ;

 if (temp_whole/100)
 text[0] = temp_whole/100 + 48;
 else
 text[0] = ' ';
 text[1] = (temp_whole/10)%10 + 48;
 text[2] = temp_whole%10 + 48;
 text[3] = ',';

 temp_fraction = temp2write << (4-RES_SHIFT);
 temp_fraction &= 0x000F;
 temp_fraction *= 625;

 text[4] = temp_fraction/1000 + 48;
 text[5] = (temp_fraction/100)%10 + 48;
 text[6] = (temp_fraction/10)%10 + 48;
 text[7] = temp_fraction%10 + 48;
 text[8] =0;

 Lcd_Out(2, 7, text);

 Lcd_Chr_CP('d');
 Lcd_Chr_CP('C');

 UART1_Write_CText("Temp = ");
 UART1_Write_Text(text);
 CRLF1();

}

void main()
{
#line 490 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_DS18B20/18F45K22_DS18B20_OneWire.c"
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=1;
 OSCCON.SCS1=1;
 OSCCON.SCS0=0;

 while(OSCCON.HFIOFS==0);



 Init_Hardware();

 txt=&TEXTE[0];



 UART1_Init(19200);
 while (UART1_Tx_Idle() == 1) UART1_Write(13);
 UART1_Write( 12 );
 Delay_ms(500);
 CRLF1();

 UART1_Write_CText("Mikroc Pro 6.620\r\n ");
 UART1_Write_CText("version :" "02-01-2016" "\r\n");
 UART1_Write_CText("Source :" "18F45K22_DS18B20_OneWire.c" "\r\n");
 UART1_Write_CText("18F45K22 Ready for PIC\r\n ");
 UART1_Write_CText("LCD COG2x16 mode 4 bits sur PORTD \r\n");
 UART1_Write_CText("UART1 via USB -> COM23 Vbray Terminal\r\n ");
 UART1_Write_CText("Test specifiq. capteur OWS DS18B20 \r\n\r\n");

 Freq = Clock_kHz();
 UART1_Write_CText(" Fosc =");
 LongWordToStr(Freq, txt) ;
 UART1_Write_Text(txt);
 UART1_Write_CText(" KHz\r\n");
 UART1_Write_CText(" Check delay de 5000mS entre # et @\r\n");
 UART1_Write('#'); CRLF1();
 Delay_ms(5000);
 UART1_Write('@'); CRLF1();

 UART1_Write_CText("init UART1 19200,8,N,1\r\n ");
 UART1_Write_CText("Init LCD COG 2x16 mode 4 bits \r\n ");


 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Resolution();
 Display_SerialNumber();
 Delay_ms(1000);
 Display_Type();


 do
 {
 Read_Temperature();

 Display_Temperature();
 Delay_ms(1000);
 } while (1);
}
